﻿601,100
602,"QueBIT - Cleanup Subsets and Views"
562,"NULL"
586,
585,
564,
565,"z[S>uNGic0xPXNNfF:kzwXRTj9a52UxOJe2b<WEDJ4TG]m<62R@SOc?j\4xbYXoCxEB[c\M\^5LDWywUFghc^tAAC@WHGo`GZ1v`6MIf7=A2C2]7OX\77C;H]=bkqR][1>3]>fvni>pK192Fn4Tl@@R8IwE^s1wZqJ^E]n?dOQuyG8rEFxhuf3K`T6oKICKe^eJZFBvl"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,2
pDataDirectory
pString
561,2
2
2
590,2
pDataDirectory,"D:\TM1\Data"
pString,""
637,2
pDataDirectory,"Enter Data Directory"
pString,"Enter the string you are looking to remove for subsets/views"
577,0
578,0
579,0
580,0
581,0
582,0
603,0
572,135

#****Begin: Generated Statements***
#****End: Generated Statements****

#####################################
# QueBIT Standard TI - Cleanup Subsets and Views
#####################################
# © 2015 QueBIT Consulting LLC
#
# PURPOSE:
#   This process will delete Views and Subsets that accumulate due to errors in TI Processes
#       when a TI Process errors out it cannot generally finish execution and delete temporary views and subsets
#       used in data processing
#    To accomplish this the process will search the TM1 Data directory for .sub and .vue files which correspond to the Subsets and Views within the server
#       This is required due to the fact that TM1 does not have a native search function within Turbo Integrator Script
#
# NOTE: 
#   CAUTION must be used when running this process as it will delete any view/subset that contains the string entered into the parameters
#
# PARAMETERS:
#   pDataDirectory - Enter the TM1 Data directory to be searched for files
#   pString - Enter the string for the process to SCAN for and subsequently delete files
#
# MODFICATION HISTORY:
#     2015-08-07: Created/RH
#     2020-03-26: Boilerplate modified for distribution/AGT
#####################################

cStringIgnore = 'zTI_Default';

#######################################
# Ensure that there is a search parameter for the subsets
#######################################
IF ( pString @= '' ) ;
  PROCESSERROR;
ENDIF;

##################
# Validate Data Directory
##################
IF ( pDataDirectory @= '' ) ;
  PROCESSERROR;
ENDIF;

IF ( SUBST ( pDataDirectory, LONG ( pDataDirectory) , 1 ) @<> '\' ) ;
  pDataDirectory = pDataDirectory | '\' ;
ENDIF;

#################
# Cleanup Public Views
#################

vCubeCount = 1;
vMaxCubeCount = DIMSIZ ( '}Cubes' ) ;

thisFile = '' ;
lastFile = '' ;

### Loop through cubes which will then become the folder path
WHILE ( vCubeCount <= vMaxCubeCount ) ;
  thisCube = DIMNM ( '}Cubes', vCubeCount ) ;
  thisWildcard = pDataDirectory | thisCube | '}Vues\*.vue' ;
  vContinue = 1;

  ### Search for Views
  WHILE ( vContinue = 1 ) ;
    thisFile = WILDCARDFILESEARCH ( thisWildcard, lastFile ) ;

    IF ( thisFile @= '' ) ;
      vContinue = 0 ;

    ### Check View Files
    ELSE;
      thisView = SUBST ( thisFile, 1, LONG ( thisFile ) - 4 ) ;
    
      ### Delete views if they have the string entered into the parameters
      IF ( SCAN ( pString, thisView ) <> 0 & thisView @<> cStringIgnore  ) ;
        ASCIIOUTPUT ( 'test.txt', thisView, NUMBERTOSTRING ( SCAN ( pString, thisView ) ), pString  ) ;
        IF ( VIEWEXISTS ( thisCube, thisView ) = 1 ) ;
           VIEWDESTROY ( thisCube, thisView ) ;
        ENDIF;
      ENDIF;

    ENDIF;
    lastFile = thisFile ;
  END;

  vCubeCount = vCubeCount + 1;

END;


###################
# Cleanup Public Subsets
###################

vDimensionCount = 1;
vDimensionMax = DIMSIZ ( '}Dimensions' ) ;

thisFile = '';
lastFile = '';

### Loop through dimensions which will then become the folder path
WHILE ( vDimensionCount <= vDimensionMax ) ;
  thisDimension = DIMNM ( '}Dimensions', vDimensionCount ) ;
  thisWildcard = pDataDirectory | thisDimension | '}Subs\*.sub' ;
  vContinue = 1;

  ### Search for Subsets
  WHILE ( vContinue = 1 ) ;
    thisFile = WILDCARDFILESEARCH ( thisWildcard, lastFile ) ;
  
    IF ( thisFile @= '' ) ;
      vContinue = 0 ;

    ### Check Subset Files
    ELSE;
      thisSubset = SUBST ( thisFile, 1, LONG ( thisFile) - 4 ) ;
      
      ### Delete subsets if htey have the string entered into the parameters
      IF ( SCAN ( pString, thisSubset ) <> 0 & thisSubset @<> cStringIgnore ) ;
        IF ( SUBSETEXISTS ( thisDimension, thisSubset ) = 1 ) ;
           SUBSETDESTROY ( thisDimension, thisSubset ) ;
        ENDIF;
      ENDIF;

    ENDIF;
    lastFile = thisFile ;
  END;

  vDimensionCount = vDimensionCount + 1;

END;


573,3

#****Begin: Generated Statements***
#****End: Generated Statements****
574,3

#****Begin: Generated Statements***
#****End: Generated Statements****
575,3

#****Begin: Generated Statements***
#****End: Generated Statements****
576,CubeAction=1511DataAction=1503CubeLogChanges=0
930,0
638,1
804,0
1217,1
900,
901,
902,
938,0
937,
936,
935,
934,
932,0
933,0
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
